﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="CopyPasteFromExcel.WebForm1" %>
<%@ Register TagPrefix="ig" Namespace="Infragistics.Web.UI.GridControls" Assembly="Infragistics4.Web.v16.1, Version=16.1.20161.2163, Culture=neutral, PublicKeyToken=7dd5c3163f2cd0cb"  %>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.10.2/jquery.min.js" type="text/javascript"></script>
    <script src="http://ajax.googleapis.com/ajax/libs/jqueryui/1.10.3/jquery-ui.min.js" type="text/javascript"></script>

    <script type="text/javascript">
                function reenableSubmitButton() {
                    var buttonId = document.getElementById('btnRequest');
                    buttonId.disabled = false;
                    buttonId.value = 'Upload Request';
                }

                function clientValidation(source, args) {
                    if (args.IsValid)
                        args.IsValid = buildFrm();
                    if (!args.IsValid)
                        reenableSubmitButton()
                }
                function buildFrm() {
                    var grid = $find('<%= this.WebDataGrid1.ClientID %>');
                    //Doing some Client Side Validations
                    return true;
                }
                function WebDataGridView_Initialize(sender, eventArgs) {
                   sender._callbackManager.setTimeout(600000);
                   var webGrid = $find('<%= this.WebDataGrid1.ClientID %>');
                   if (!webGrid) return;
                   // refefrence to grid columns
                   var aGridCols = webGrid.get_columns(); if (!aGridCols) return;
                   var iColCount = aGridCols.get_length(); if (iColCount == 0) return;
                   var oCol;
                   var iColLength = 0;
                   // looping thru grid columns, checking width
                   for (var I = 0; I < iColCount; I++) {
                       oCol = aGridCols.get_column(I);
                       if (!oCol.get_hidden()) {
                           // If header width is less then data width - resize column
                           if (oCol.get_headerElement().offsetWidth <
                         oCol.get_headerText().length * 8) {
                               var len = oCol.get_headerText().length * 8;
                               oCol.set_width(len + 'px');
                           }
                           // calculating total size of columns
                           iColLength += oCol.get_headerElement().offsetWidth;
                       }
                   }
                   //setting grid width to summary width of all columns
                   webGrid.get_rows().get_element().parentElement.style.width = iColLength + 'px';
               }
               function keyUp(grid, args) {
                   var evt = args.get_browserEvent();
                   if (evt.ctrlKey && evt.keyCode == 86) // Ctrl-V
                   {
                       if (grid.get_behaviors().get_activation() != null) {
                           var activeCell = grid.get_behaviors().get_activation().get_activeCell();
                           var clipboardText = getClipboardData();
                           if (activeCell && clipboardText) {
                               // Excel stores its data in text clipboard separated 
                               // by \n between rows and by \t between cells
                               var pasteData = clipboardText.split("\n");
                               for (var i = 0; i < pasteData.length; i++)
                                   pasteData[i] = pasteData[i].split("\t");

                               // Last row may be a dummy row
                               if (pasteData[pasteData.length - 1].length == 1 && pasteData[pasteData.length - 1][0] == "")
                                   delete pasteData[pasteData.length - 1];

                               var rowDataIndex = 0;
                               var rowIndex = activeCell.get_row().get_index();

                               // Let's paste until the end of our clipboard data or until the end of the grid rows
                               while (rowDataIndex < pasteData.length && rowIndex < grid.get_rows().get_length()) {
                                   var row = grid.get_rows().get_row(rowIndex++);

                                   var cellDataIndex = 0;
                                   var cellData = pasteData[rowDataIndex++];
                                   var cellIndex = activeCell.get_index();

                                   //Let's paste until the end of the clipboard data or until the end of the cells
                                   while (cellData && cellDataIndex < cellData.length && cellIndex < row.get_cellCount()) {
                                       var text = cellData[cellDataIndex++];
                                       if (text === null)
                                           break;
                                       var cell = row.get_cell(cellIndex++);
                                       cell.set_value(text);
                                   }
                               }
                           }
                       }
                   }
                   if (evt.keyCode == 127) {
                       if (grid.get_behaviors().get_selection() != null) {
                           var cells = grid.get_behaviors().get_selection().get_selectedCells();
                           for (var i = cells.get_length() - 1; i >= 0; i--) {
                               var cell = cells.getItem(i);
                               cell.set_value(undefined, undefined);
                           }
                       }
                   }
               }

               var _browserPasteData = null;
               function getClipboardData() {
                   if (_browserPasteData) // Safari/Chrome logic
                       return _browserPasteData;

                   if (window.clipboardData) // IE logic
                   {
                       return window.clipboardData.getData("Text");
                   }
                   else if (typeof (netscape) != "undefined") // Firefox logic
                   {
                       netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
                       var clip = Components.classes["@mozilla.org/widget/clipboard;1"].createInstance(Components.interfaces.nsIClipboard);
                       var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
                       trans.addDataFlavor("text/unicode");
                       clip.getData(trans, clip.kGlobalClipboard);
                       var str = new Object();
                       var len = new Object();
                       trans.getTransferData("text/unicode", str, len);
                       if (str)
                           return str.value.QueryInterface(Components.interfaces.nsISupportsString).toString();
                   }
                   return null;
               }

               // In Safari/Chrome the clipboard data can only be accessed
               // from the onpaste event. In this sample the event is handled 
               // off the body element: <body onpaste="browserPaste(event)">
               function browserPaste(e) {
                   _browserPasteData = e.clipboardData && e.clipboardData.getData ?
	        e.clipboardData.getData('text/plain') : null;

               }
        </script>

    <style>
    </style>
</head>
<body>
    <form id="form1" runat="server">
        <div>
            <asp:ScriptManager ID="ScriptManager1" runat="server" EnableScriptGlobalization="true"></asp:ScriptManager>
            <ig:WebDataGrid ID="WebDataGrid1" BorderWidth="1" runat="server" AutoGenerateColumns="False" Height="400px" width="99.5%" DataKeyFields="row_nbr"
                EnableDataViewState="true" EnableViewState="true"  EnableAjax="false" EnableAjaxViewState="false" DefaultColumnWidth="150px">
                <Columns>
                   <ig:BoundDataField DataFieldName="A" Key="A">
                       <Header Text="A" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="B" Key="B">
                       <Header Text="B" />
                   </ig:BoundDataField>
                   <ig:BoundDataField DataFieldName="C" Key="C">
                       <Header Text="C" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="D" Key="D">
                       <Header Text="D" />
                   </ig:BoundDataField>
                   <ig:BoundDataField DataFieldName="E" Key="E">
                       <Header Text="E" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="F" Key="F">
                       <Header Text="F" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="G" Key="G">
                       <Header Text="G" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="H" Key="H">
                       <Header Text="H" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="I" Key="I">
                       <Header Text="I" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="J" Key="J">
                       <Header Text="J" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="K" Key="K">
                       <Header Text="K" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="L" Key="L">
                       <Header Text="L" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="M" Key="M">
                       <Header Text="M" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="N" Key="N">
                       <Header Text="N" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="O" Key="O">
                       <Header Text="O" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="P" Key="P">
                       <Header Text="P" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="Q" Key="Q">
                       <Header Text="Q" />
                   </ig:BoundDataField>
                   <ig:BoundDataField DataFieldName="R" Key="R">
                       <Header Text="R" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="S" Key="S">
                       <Header Text="S" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="T" Key="T">
                       <Header Text="T" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="U" Key="U">
                       <Header Text="U" />
                   </ig:BoundDataField>
                   <ig:BoundDataField DataFieldName="V" Key="V">
                       <Header Text="V" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="W" Key="W">
                       <Header Text="W" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="X" Key="X">
                       <Header Text="X" />
                   </ig:BoundDataField>
                    <ig:BoundDataField DataFieldName="Y" Key="Y">
                       <Header Text="Y" />
                   </ig:BoundDataField>
                </Columns>
                <Behaviors>
                    <ig:Selection CellClickAction="Cell" ColumnSelectType="multiple" CellSelectType="multiple">
                    </ig:Selection>
                    <ig:Activation Enabled="true"></ig:Activation>
                    <ig:EditingCore BatchUpdating="true" Enabled="true" AutoCRUD="false">
                        <Behaviors>
                            <ig:CellEditing Enabled="true"></ig:CellEditing>
                        </Behaviors>
                    </ig:EditingCore>
                    <ig:Clipboard>
                    </ig:Clipboard>
                    <ig:ColumnResizing Enabled="false"></ig:ColumnResizing>
                    <ig:ColumnFixing Enabled="false"></ig:ColumnFixing>
                    <ig:RowSelectors RowNumbering="True">
                    </ig:RowSelectors>
                </Behaviors>
            </ig:WebDataGrid>
        </div>
        <asp:button id="btnRequest" runat="server" Text="Upload Request" UseSubmitBehavior="false" OnClientClick="this.disabled=true;this.value='Processing...';" ></asp:button>
        <asp:customvalidator id="CustomValidator1" runat="server" Display="Dynamic" EnableViewState="False" ClientValidationFunction="clientValidation"></asp:customvalidator>
    </form>
</body>
</html>
