﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace CopyPasteFromExcel
{
    public partial class WebForm1 : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                ViewState["data"] = null;
            }
            WebDataGrid1.DataSource = GetGridDataTable();
            WebDataGrid1.DataBind();
        }
        public DataTable GetGridDataTable()
        {
            DataTable table = new DataTable();
            DataColumn column = new DataColumn();
            column.ColumnName = "row_nbr";
            column.DataType = System.Type.GetType("System.Int32");
            column.AutoIncrement = true;
            column.AutoIncrementSeed = 1;
            column.AutoIncrementStep = 1;
            table.Columns.Add(column);

            table.Columns.Add("A", typeof(string));
            table.Columns.Add("B", typeof(string));
            table.Columns.Add("C", typeof(string));
            table.Columns.Add("D", typeof(string));
            table.Columns.Add("E", typeof(string));
            table.Columns.Add("F", typeof(string));
            table.Columns.Add("G", typeof(string));
            table.Columns.Add("H", typeof(string));
            table.Columns.Add("I", typeof(string));
            table.Columns.Add("J", typeof(string));
            table.Columns.Add("K", typeof(string));
            table.Columns.Add("L", typeof(string));
            table.Columns.Add("M", typeof(string));
            table.Columns.Add("N", typeof(string));
            table.Columns.Add("O", typeof(string));
            table.Columns.Add("P", typeof(string));
            table.Columns.Add("Q", typeof(string));
            table.Columns.Add("R", typeof(string));
            table.Columns.Add("S", typeof(string));
            table.Columns.Add("T", typeof(string));
            table.Columns.Add("U", typeof(string));
            table.Columns.Add("V", typeof(string));
            table.Columns.Add("W", typeof(string));
            table.Columns.Add("X", typeof(string));
            table.Columns.Add("Y", typeof(string));

            table.PrimaryKey = new DataColumn[] { table.Columns["row_nbr"] };

            if (ViewState["data"] != null)
            {
                table = (DataTable)ViewState["data"];
                int rowCount = table.Rows.Count;
                if (rowCount <= 1000)
                {
                    for (int i = (rowCount + 1); i <= 1000; i++)
                    {
                        table.Rows.Add(i);
                    }

                }
            }
            else
            {
                for (int i = 0; i < 1000; i++)
                {
                    table.Rows.Add(i);
                }
            }
            return table;
        }

        override protected void OnInit(EventArgs e)
        {
            InitializeComponent();
            base.OnInit(e);
        }
        private void InitializeComponent()
        {
            this.btnRequest.Click += new EventHandler(this.btnRequest_Click);
            this.Load += new EventHandler(this.Page_Load);
        }
        protected void btnRequest_Click(object sender, EventArgs e)
        {
            //getting the datas from web datagrid and sending to DB
        }
    }
}